package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.OffSiteTransportationMapper;
import com.steerinfo.dil.model.TmstruckReceiptResult;
import com.steerinfo.dil.service.ITmstruckReceiptResultService;
import com.steerinfo.dil.service.OffSiteTransportationService;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.route.mapper.TmstruckArrivalResultMapper;
import com.steerinfo.route.model.TmstruckReceiptResultChild;
import com.steerinfo.route.service.ITmstruckReceiptResultChildService;
import com.steerinfo.route.service.impl.RouteServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestBody;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@Service
public class OffSiteTransportationServiceImpl implements OffSiteTransportationService {
    @Autowired
    private RouteServiceImpl routeService;
    @Autowired
    OffSiteTransportationMapper offSiteTransportationMapper;
    @Autowired
    private TmstruckArrivalResultMapper tmstruckArrivalResultMapper;
    @Autowired
    private ITmstruckReceiptResultService  tmstruckReceiptResultService;
    @Autowired
    private  ITmstruckReceiptResultChildService  tmstruckReceiptResultChildService;
    @Override
    public List<Map<String, Object>> getInTransitTransportation(Map<String, Object> mapValue) {
        return offSiteTransportationMapper.getInTransitTransportation(mapValue);
    }

    @Override
    public Integer getOrderStatus(Map<String, Object> map) {
        String orderNumber = (String) map.get("orderNumber");
        //判断是否已经结束
        Integer statu= offSiteTransportationMapper.getOrderStatu(orderNumber);
        if (statu==null){
            return 1;
        }
        return statu;
    }

    @Override
    public Map<String, Object> getStartAndEndCapacityNumber(Map<String,Object> map) {
        return offSiteTransportationMapper.getStartAndEndCapacityNumber(map);
    }

    @Override
    public void   insertOrderMileage(Map<String, Object> map) {
        //获取运输订单号
        String orderNumber = (String) map.get("orderNumber");
        //获取并插入总实绩Id
        BigDecimal truckTotalId = tmstruckArrivalResultMapper.getTotalIdByOrderNumber(orderNumber);
        //获取总距离
        String orderMileage = (String) map.get("orderMileage");
        //将两个属性放到运输订单中
        HashMap<String,Object> omstruckOrder=new HashMap<>();
        omstruckOrder.put("truckTotalId",truckTotalId);
        omstruckOrder.put("orderMileage",orderMileage);
         offSiteTransportationMapper.insertOrderMileage(omstruckOrder);

    }

    @Override
    public void removeDate() {
       List<Map<String,Object>> list= offSiteTransportationMapper.getReceiptData();
       for (Map<String,Object> map:list){
         int i=  offSiteTransportationMapper.insertReceive(map);
       }
    }

    public int orderClose(String orderNumber){
        return offSiteTransportationMapper.orderClose(orderNumber);
    }

    public String savePath() throws Exception {

        Map<String, Object> parem=offSiteTransportationMapper.getTruckFactoryResult("WYSDD2021091000000002");
        parem.put("turnOf","0");
        return routeService.saveRoute(parem).toString();
        //运输订单号：orderNumber、车牌号：capacityNumber、出厂时间:resultOutGateTime、预警开关：turnOf、发货地址:shipperName、收货地址:receiveAddress
        //初始化请求参数
//        HashMap<String,Object> mapValue=new HashMap<>();
//        mapValue.put("orderNumber","WYSDD2021091000000001");
//        mapValue.put("capacityNumber","豫SB6238");
//        mapValue.put("resultOutGateTime","2021-11-17 14:20:19");
//        mapValue.put("turnOf","0");
//        mapValue.put("shipperName","四川达州钢铁集团有限");
//        mapValue.put("receiveAddress","长沙市");
//        return routeService.saveRoute(parem).toString();
    }

    public Integer addTmstruckReceiptResult(@RequestBody(required = false) Map<String,Object> map){
        BigDecimal alreadyExistsArrivalResult = tmstruckArrivalResultMapper.alreadyExistsArrivalResult((String) map.get("orderNumber"));
        if(alreadyExistsArrivalResult!=null){
            TmstruckReceiptResult tmstruckReceiptResult = new TmstruckReceiptResult();
            //获取运输订单号和收货点地址
            String orderNumber = (String) map.get("orderNumber");
            String resultArrivalAddress = (String) map.get("resultArrivalAddress");
            //获取空货箱照片、已签字的送货单照片
            String resultEmptyContainerPhoto = (String) map.get("url0");
            String resultSignedNotePhoto = (String) map.get("url1");
            tmstruckReceiptResult.setResultArrivalAddress(resultArrivalAddress);
            tmstruckReceiptResult.setResultEmptyContainerPhoto(resultEmptyContainerPhoto);
            tmstruckReceiptResult.setResultSignedNotePhoto(resultSignedNotePhoto);
            if(map.containsKey("url3")){
                //如果有，获取客户签收单照片
                String resultReceiveNotePhoto = (String) map.get("url3");
                tmstruckReceiptResult.setResultReceiveNotePhoto(resultReceiveNotePhoto);
            }
            //新增收货实绩主表
            BigDecimal receiptResultId = tmstruckReceiptResultService.addTmstruckReceiptResult(orderNumber, tmstruckReceiptResult);
            //初始化收货实绩子表信息
            TmstruckReceiptResultChild tmstruckReceiptResultChild = new TmstruckReceiptResultChild();
            //关联收货实绩主表
            tmstruckReceiptResultChild.setReceiptResultId(receiptResultId);
            //如果有，获取最多三张其他照片
            if(map.containsKey("fourFiles")){
                List<String> fourFiles = (List<String>) map.get("fourFiles");
                if(fourFiles.size()==0){}
                else if(fourFiles.size()==1){
                    tmstruckReceiptResultChild.setOtherPhoto1(fourFiles.get(0));
                }else if(fourFiles.size()==2){
                    tmstruckReceiptResultChild.setOtherPhoto1(fourFiles.get(0));
                    tmstruckReceiptResultChild.setOtherPhoto2(fourFiles.get(1));
                }else {
                    tmstruckReceiptResultChild.setOtherPhoto1(fourFiles.get(0));
                    tmstruckReceiptResultChild.setOtherPhoto2(fourFiles.get(1));
                    tmstruckReceiptResultChild.setOtherPhoto3(fourFiles.get(2));
                }
            }
            //新增收货实绩子表
            int i = tmstruckReceiptResultChildService.addTmstruckReceiptResultChild(tmstruckReceiptResultChild);
            return i;
        }else{
            return 4;
        }

    }
}